/* linux/include/asm/arch-s3c2410/buttons.h
 *
 * Copyright (c) 2005 Arnaud Patard <arnaud.patard@rtp-net.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 */

#ifndef __ASM_ARM_BUTTONS_H
#define __ASM_ARM_BUTTONS_H

#include <linux/input.h>

struct s3c_button {
	int		pin;
	int		keycode;
	char		*name;
	char		wake;
	int		irq;
	int		last_state;
        int 		ev_down;
        int 		ev_up;
        int 		ev_repeat;
	struct timer_list timer;
};

struct s3c_butt_mach_info {
	struct s3c_button	*buttons;
	int			size;
};

#define DECLARE_BUTTON(p, k, n, w)	\
	{				\
		.pin     = p,		\
		.keycode = k,		\
		.name	 = n,		\
		.wake	 = w,		\
	}


struct s3c2410_button {
	int pin;
	int keycode;
	char *name;
	int irq;
	int last_state;
        int ev_down;
        int ev_up;
        int ev_repeat;
	struct timer_list timer;
};

#define DECLARE_S3C2410_BUTTON(p, k, n, l, d, u, r)	\
	{				\
		.pin     = p,		\
		.keycode = k,		\
		.name	 = n,		\
                .last_state = l,        \
		.ev_down = d,		\
                .ev_up 	 = u,		\
                .ev_repeat = r,		\
	}

struct s3c2410_butt_mach_info {
	struct s3c2410_button *buttons;
	int size;
};
extern void __init s3c2410_butt_set_platdata(struct s3c2410_butt_mach_info *);
extern void __init s3c24xx_butt_set_platdata(struct s3c_butt_mach_info *);
#endif
