
#include <linux/linkage.h>
#include <asm/errno.h>

#include <asm/io.h>
#include <asm/hardware.h>
#include <asm/mach-types.h>
#include <asm/uaccess.h>
#include <asm/mach/map.h>

#include "mhelper.h"




extern asmlinkage long
sys_mhelper(uint32_t cmd, uint32_t addr, uint32_t value)
{
	void __iomem *vaddr = 0;
	int verb;

	vaddr = ioremap(addr, 4);
	if (!vaddr)
		return -ENXIO;


	verb = (cmd & OPT_VERB);	
	cmd &= ~OPT_VERB;

        switch (cmd) {

	case CMD_READ_B:
		value = __raw_readb(vaddr);
		if (verb)
			printk("0x%08x: 0x%02x (%d)\n", 
				addr, value, value);
		break;
	case CMD_READ_W:
		value = __raw_readw(vaddr);
		if (verb)
			printk("0x%08x: 0x%04x (%d)\n", 
				addr, value, value);
		break;
	case CMD_READ_L:
		value = __raw_readl(vaddr);
		if (verb)
			printk("0x%08x: 0x%08x (%d)\n", 
				addr, value, value);
		break;

	case CMD_WRITE_B:
		__raw_writeb(value, vaddr);
		break;
	case CMD_WRITE_W:
		__raw_writew(value, vaddr);
		break;
	case CMD_WRITE_L:
		__raw_writel(value, vaddr);
		break;

	default:
		iounmap(vaddr);
		return -EINVAL;
		break;
	}

	iounmap(vaddr);
	return verb?0:value;
}

